typedef	byte		color8;	// color value index
typedef	byte		color16[2];	// 16-bit RGB color value
typedef	byte		color24[3];	// 24-bit RGB color value
typedef	byte		color32[4];	// 32-bit RGBA color value

extern	byte		*host_basepal;
extern	void RemapBackwards_Palette	(byte *p);
extern	void RemapBackwards_Pixels	(byte *i, int size);
extern	void RemapColorKey_Pixels	(byte *i, int size);

#define		COLORSHADINGMAP_SIZE (256*VID_GRADES+1)
extern	void		*colormap;
//extern	byte		*host_colormap;

#define		WITHOUT_BRIGHTS			0
#define		WITH_BRIGHTS			1
#define		CEL_WITHOUT_BRIGHTS		2 // EF_CELSHADING
#define		CEL_WITH_BRIGHTS		3 // EF_CELSHADING
#define		COLORSHADINGMAP_STYLES	4
extern	byte		**colorshadingmap;

extern	byte		*colorshadingmap_world;		// for the world model, including inline BSP models
extern	byte		*colorshadingmap_staticent;	// for non-inline static entities (efrags)
extern	byte		*colorshadingmap_beam;		// for cl_tents
extern	byte		*colorshadingmap_entity;	// for everything else
extern	byte		*colorshadingmap_player;
extern	byte		*colorshadingmap_viewmodel;
extern	cvar_t		r_brights_world;
extern	cvar_t		r_brights_staticent;
extern	cvar_t		r_brights_beam;
extern	cvar_t		r_brights_entity;
extern	cvar_t		r_brights_player;
extern	cvar_t		r_brights_viewmodel;

extern	cvar_t		r_fullbright_colors;
extern	cvar_t		r_fullbright_range;
extern	cvar_t		r_fullbright_cel_range;
extern	cvar_t		r_fullbright_cel_factor;

extern	cvar_t		gl_cshiftpercent;
extern	cvar_t		gl_polyblend; // Manoel Kasimier - gl_polyblend
extern	int			gl_polyblend_old; // Manoel Kasimier - gl_polyblend
extern	unsigned short	d_8to16table[256];
extern	unsigned	d_8to24table[256];

extern	void	Palette_Init (void);
extern	void	VID_SetPalette (unsigned char *palette); // called at startup and after any gamma correction
extern	void	VID_ShiftPalette (unsigned char *palette); // called for bonus and pain flashes, and for underwater color changes
extern	void	V_CalcDamageCshift (int armor, int blood, float count);

#define	CSHIFT_CONTENTS	0
#define	CSHIFT_DAMAGE	1
#define	CSHIFT_BONUS	2
#define	CSHIFT_POWERUP	3
#define	NUM_CSHIFTS		4

typedef struct
{
	int		destcolor[3];
	int		percent;		// 0-256
} cshift_t;

#define		COLORBLENDINGMAP_SIZE (256*256)

// drawing mode
//#define		BLEND_NONE				0 // definir NONE e SOLID juntos, variando com alpha
#define		BLEND_SOLID				0 // copy mode
#define		BLEND_STIPPLE			1
#define		BLEND_BLEND				2
#define		COLORBLENDING_MODES		3

// actual blend modes
#define		BLEND_WEIGHTEDMEAN		0
#define		BLEND_ADDITIVE			1
#define		BLEND_SMOKE				2
//#define		BLEND_MAX				3
//#define		BLEND_BINARY_OR			4
#define		COLORBLENDING_MAPS	3

extern byte		**colorblendingmode;
extern byte		*colorblendingmap; // current color blending map

extern byte D_DrawPixel_17			(byte over, byte under);
extern byte D_DrawPixel_33			(byte over, byte under);
extern byte D_DrawPixel_50			(byte over, byte under);
extern byte D_DrawPixel_67			(byte over, byte under);
extern byte D_DrawPixel_83			(byte over, byte under);

extern byte D_DrawPixel_Sky			(byte over, byte under);
extern byte D_DrawPixel_Opaque		(byte over, byte under);
extern byte D_DrawPixel_Transparent	(byte over, byte under);
